/*
 *  This file is part of Bracket Properties
 *  Copyright 2011-2013 David R. Smith
 *  All Rights Reserved
 *
 */
package asia.redact.bracket.properties.serializer;

/**
 * Tokens representing and encapsulating various java objects; from the stand point of the serializer each
 * have a general type.
 * 
 * @author Dave
 *
 */
public enum TokenType {

	R(false), N(true), B(true), P(true), S(true), I(true), LO(true), F(true), D(true), O(false), LI(false), A(false), E(false), M(false), LOADABLE(true);

	final boolean renderImmediate;
	
	private TokenType(boolean bool){
		renderImmediate= bool;
	}

	public boolean isRenderImmediate() {
		return renderImmediate;
	}
	
}
